package org.jcg.zheng;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class DemoInsertArray {

	public int[] insert_via_Array(final int[] sortedArray, final int newNumber) {
		int insertIdx = Arrays.binarySearch(sortedArray, newNumber);
		if (insertIdx < 0) {
			insertIdx = -(insertIdx + 1);
		}

		int existingArrayLength = sortedArray.length;
		// create a new array with bigger size
		int[] newArray = new int[existingArrayLength + 1];

		System.arraycopy(sortedArray, 0, newArray, 0, insertIdx);

		newArray[insertIdx] = newNumber;

		System.arraycopy(sortedArray, insertIdx, newArray, insertIdx + 1, existingArrayLength - insertIdx);

		return newArray;
	}

	public int[] insert_via_List(final int[] sortedArray, final int newNumber) {
		List<Integer> sortedList = new ArrayList<>();
		for (int n : sortedArray) {
			sortedList.add(n);
		}

		int insertIdx = Collections.binarySearch(sortedList, newNumber);
		if (insertIdx < 0) {
			insertIdx = -(insertIdx + 1);
		}
		sortedList.add(insertIdx, newNumber);

		return sortedList.stream().mapToInt(n -> n).toArray();
	}

}
